git-sh-setup.shon commit l10n: vi.po: update translation upto cc76011 (03c82da)
   1#!/bin/sh
   2#
   3# This is included in commands that either have to be run from the toplevel
   4# of the repository, or with GIT_DIR environment variable properly.
   5# If the GIT_DIR does not look like the right correct git-repository,
   6# it dies.
   7
   8# Having this variable in your environment would break scripts because
   9# you would cause "cd" to be taken to unexpected places.  If you
  10# like CDPATH, define it for your interactive shell sessions without
  11# exporting it.
  12# But we protect ourselves from such a user mistake nevertheless.
  13unset CDPATH
  14
  15# Similarly for IFS
  16unset IFS
  17
  18git_broken_path_fix () {
  19        case ":$PATH:" in
  20        *:$1:*) : ok ;;
  21        *)
  22                PATH=$(
  23                        SANE_TOOL_PATH="$1"
  24                        IFS=: path= sep=
  25                        set x $PATH
  26                        shift
  27                        for elem
  28                        do
  29                                case "$SANE_TOOL_PATH:$elem" in
  30                                (?*:/bin | ?*:/usr/bin)
  31                                        path="$path$sep$SANE_TOOL_PATH"
  32                                        sep=:
  33                                        SANE_TOOL_PATH=
  34                                esac
  35                                path="$path$sep$elem"
  36                                sep=:
  37                        done
  38                        echo "$path"
  39                )
  40                ;;
  41        esac
  42}
  43
  44# @@BROKEN_PATH_FIX@@
  45
  46die () {
  47        die_with_status 1 "$@"
  48}
  49
  50die_with_status () {
  51        status=$1
  52        shift
  53        echo >&2 "$*"
  54        exit "$status"
  55}
  56
  57GIT_QUIET=
  58
  59say () {
  60        if test -z "$GIT_QUIET"
  61        then
  62                printf '%s\n' "$*"
  63        fi
  64}
  65
  66if test -n "$OPTIONS_SPEC"; then
  67        usage() {
  68                "$0" -h
  69                exit 1
  70        }
  71
  72        parseopt_extra=
  73        [ -n "$OPTIONS_KEEPDASHDASH" ] &&
  74                parseopt_extra="--keep-dashdash"
  75
  76        eval "$(
  77                echo "$OPTIONS_SPEC" |
  78                        git rev-parse --parseopt $parseopt_extra -- "$@" ||
  79                echo exit $?
  80        )"
  81else
  82        dashless=$(basename "$0" | sed -e 's/-/ /')
  83        usage() {
  84                die "Usage: $dashless $USAGE"
  85        }
  86
  87        if [ -z "$LONG_USAGE" ]
  88        then
  89                LONG_USAGE="Usage: $dashless $USAGE"
  90        else
  91                LONG_USAGE="Usage: $dashless $USAGE
  92
  93$LONG_USAGE"
  94        fi
  95
  96        case "$1" in
  97                -h)
  98                echo "$LONG_USAGE"
  99                exit
 100        esac
 101fi
 102
 103set_reflog_action() {
 104        if [ -z "${GIT_REFLOG_ACTION:+set}" ]
 105        then
 106                GIT_REFLOG_ACTION="$*"
 107                export GIT_REFLOG_ACTION
 108        fi
 109}
 110
 111git_editor() {
 112        if test -z "${GIT_EDITOR:+set}"
 113        then
 114                GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
 115        fi
 116
 117        eval "$GIT_EDITOR" '"$@"'
 118}
 119
 120git_pager() {
 121        if test -t 1
 122        then
 123                GIT_PAGER=$(git var GIT_PAGER)
 124        else
 125                GIT_PAGER=cat
 126        fi
 127        : ${LESS=-FRSX}
 128        export LESS
 129
 130        eval "$GIT_PAGER" '"$@"'
 131}
 132
 133sane_grep () {
 134        GREP_OPTIONS= LC_ALL=C grep "$@"
 135}
 136
 137sane_egrep () {
 138        GREP_OPTIONS= LC_ALL=C egrep "$@"
 139}
 140
 141is_bare_repository () {
 142        git rev-parse --is-bare-repository
 143}
 144
 145cd_to_toplevel () {
 146        cdup=$(git rev-parse --show-toplevel) &&
 147        cd "$cdup" || {
 148                echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
 149                exit 1
 150        }
 151}
 152
 153require_work_tree_exists () {
 154        if test "z$(git rev-parse --is-bare-repository)" != zfalse
 155        then
 156                die "fatal: $0 cannot be used without a working tree."
 157        fi
 158}
 159
 160require_work_tree () {
 161        test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
 162        die "fatal: $0 cannot be used without a working tree."
 163}
 164
 165require_clean_work_tree () {
 166        git rev-parse --verify HEAD >/dev/null || exit 1
 167        git update-index -q --ignore-submodules --refresh
 168        err=0
 169
 170        if ! git diff-files --quiet --ignore-submodules
 171        then
 172                echo >&2 "Cannot $1: You have unstaged changes."
 173                err=1
 174        fi
 175
 176        if ! git diff-index --cached --quiet --ignore-submodules HEAD --
 177        then
 178                if [ $err = 0 ]
 179                then
 180                    echo >&2 "Cannot $1: Your index contains uncommitted changes."
 181                else
 182                    echo >&2 "Additionally, your index contains uncommitted changes."
 183                fi
 184                err=1
 185        fi
 186
 187        if [ $err = 1 ]
 188        then
 189                test -n "$2" && echo >&2 "$2"
 190                exit 1
 191        fi
 192}
 193
 194get_author_ident_from_commit () {
 195        pick_author_script='
 196        /^author /{
 197                s/'\''/'\''\\'\'\''/g
 198                h
 199                s/^author \([^<]*\) <[^>]*> .*$/\1/
 200                s/.*/GIT_AUTHOR_NAME='\''&'\''/p
 201
 202                g
 203                s/^author [^<]* <\([^>]*\)> .*$/\1/
 204                s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
 205
 206                g
 207                s/^author [^<]* <[^>]*> \(.*\)$/@\1/
 208                s/.*/GIT_AUTHOR_DATE='\''&'\''/p
 209
 210                q
 211        }
 212        '
 213        encoding=$(git config i18n.commitencoding || echo UTF-8)
 214        git show -s --pretty=raw --encoding="$encoding" "$1" -- |
 215        LANG=C LC_ALL=C sed -ne "$pick_author_script"
 216}
 217
 218# Clear repo-local GIT_* environment variables. Useful when switching to
 219# another repository (e.g. when entering a submodule). See also the env
 220# list in git_connect()
 221clear_local_git_env() {
 222        unset $(git rev-parse --local-env-vars)
 223}
 224
 225
 226# Platform specific tweaks to work around some commands
 227case $(uname -s) in
 228*MINGW*)
 229        # Windows has its own (incompatible) sort and find
 230        sort () {
 231                /usr/bin/sort "$@"
 232        }
 233        find () {
 234                /usr/bin/find "$@"
 235        }
 236        # git sees Windows-style pwd
 237        pwd () {
 238                builtin pwd -W
 239        }
 240        is_absolute_path () {
 241                case "$1" in
 242                [/\\]* | [A-Za-z]:*)
 243                        return 0 ;;
 244                esac
 245                return 1
 246        }
 247        ;;
 248*)
 249        is_absolute_path () {
 250                case "$1" in
 251                /*)
 252                        return 0 ;;
 253                esac
 254                return 1
 255        }
 256esac
 257
 258# Make sure we are in a valid repository of a vintage we understand,
 259# if we require to be in a git repository.
 260if test -z "$NONGIT_OK"
 261then
 262        GIT_DIR=$(git rev-parse --git-dir) || exit
 263        if [ -z "$SUBDIRECTORY_OK" ]
 264        then
 265                test -z "$(git rev-parse --show-cdup)" || {
 266                        exit=$?
 267                        echo >&2 "You need to run this command from the toplevel of the working tree."
 268                        exit $exit
 269                }
 270        fi
 271        test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
 272                echo >&2 "Unable to determine absolute path of git directory"
 273                exit 1
 274        }
 275        : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
 276fi